//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Unit2.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm2 *Form2;
TPicture *PictureObject;
char ExecName[80];
char Action[80];
//---------------------------------------------------------------------------
__fastcall TForm2::TForm2(TComponent* Owner)
	: TForm(Owner)
{
}
//--------------------------------------------------------------------------- 
void __fastcall TForm2::FormCreate(TObject *Sender)
{
strcpy(CaptionSave,Form2->Caption.c_str());	
}
//---------------------------------------------------------------------------
void __fastcall TForm2::FormShow(TObject *Sender)
{
Form2->Caption = CaptionSave + (AnsiString)" - " + Action;	
Form2->Canvas->CopyMode = cmSrcCopy;
First = True;
if (! strcmp(Action,"Random")) {
  TimerExec1->OnTimer = ActionRandom;
  randomize();
  NDraw=50; 
  }
else if (! strcmp(Action,"Fir-tree")) {
  TimerExec1->OnTimer = ActionFirTree;
  NDraw=50; 
  }    
else { //Simple
  TimerExec1->OnTimer = ActionSimple;
  NDraw=50; 
  }  

ImageExec1->Picture=PictureObject;
EditExec1->Text=ExecName;
if (! strcmp(ExecName,"Slow")) TimerExec1->Interval=1000;
else if (! strcmp(ExecName,"Fast")) TimerExec1->Interval=100;
else TimerExec1->Interval=500;  // Medium

if (! PictureObject) TimerExec1->OnTimer = ActionNoObject;
TimerExec1->Enabled=True;
}
//---------------------------------------------------------------------------
void __fastcall TForm2::ActionNoObject(TObject *Sender)
{
TimerExec1->Enabled = False;
MessageBox(0,"No picture object","Error",MB_OK);
ModalResult = mrOk; 	
}
//---------------------------------------------------------------------------
void __fastcall TForm2::ActionRandom(TObject *Sender)
{
if (NDraw <= 0) ModalResult = mrOk; 	
Form2->Canvas->Draw(GroupBoxExec1->Left+random(GroupBoxExec1->Width),
                    GroupBoxExec1->Top+random(GroupBoxExec1->Height),
                    PictureObject->Graphic);  
NDraw--;                    
}
//---------------------------------------------------------------------------
void __fastcall TForm2::ActionSimple(TObject *Sender)
{
int w,h;
if (NDraw <= 0) ModalResult = mrOk; 
if (First) { InitSimple(); First=False; }
if (NDraw % 2) Form2->Canvas->CopyMode = cmNotSrcCopy; // odd
else Form2->Canvas->CopyMode = cmSrcCopy;
w = PictureObject->Graphic->Width;
h = PictureObject->Graphic->Height;
Form2->Canvas->Draw(Centre.x - w/2,Centre.y - h/2,PictureObject->Graphic);
NDraw--; 
}
//---------------------------------------------------------------------------
void __fastcall TForm2::InitSimple()
{
int aRR;
TRect RR;
L=GroupBoxExec1->Left;
W=GroupBoxExec1->Width;
T=GroupBoxExec1->Top;
H=GroupBoxExec1->Height;
Centre.x=L+W/2; Centre.y=T+H/2;
aRR=30;
RR.Left=Centre.x-aRR; RR.Top=Centre.y-aRR;
RR.Right=Centre.x+aRR; RR.Bottom=Centre.y+aRR;
Form2->Canvas->Brush->Color=clWhite;
Form2->Canvas->FillRect(RR);
}
//---------------------------------------------------------------------------
void __fastcall TForm2::ActionFirTree(TObject *Sender)
{
int i,X,Y;
if (First) { InitFirTree(); First=False; nb=np=1; }
Y=TreeT+TreeDelta*(nb-1)+(np/2)*(TreeDelta/2);
switch (np) {
  case 1: X=TreeX-(np/2)*(Branch/2);
        np++; break;
  case 2: X=TreeX-(np/2)*(Branch/2);
        np++; break;
  case 3: X=TreeX+(np/2)*(Branch/2)-PictureObject->Graphic->Width;;
        np++; break;
  case 4: X=TreeX-(np/2)*(Branch/2);
        np++; break;
  case 5: X=TreeX+(np/2)*(Branch/2)-PictureObject->Graphic->Width;;
        np=1; nb++; break;                        
  }
Form2->Canvas->Draw(X,Y,PictureObject->Graphic);
if (nb > Nbr) {
  TimerExec1->Enabled = False;
  TimerExec1->OnTimer = ViewFirTree;
  TimerExec1->Interval = 5000;
  TimerExec1->Enabled = True;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm2::InitFirTree()
{
int i;
L=GroupBoxExec1->Left;
W=GroupBoxExec1->Width;
T=GroupBoxExec1->Top;
H=GroupBoxExec1->Height;
Form2->Canvas->Pen->Width=7;
Form2->Canvas->Pen->Color=clBlack;
TreeT=T;  TreeB=T+H;  TreeX=L+W/2;
Nbr=4;
TreeDelta=(TreeB-TreeT)/Nbr;
Branch=(TreeB-TreeT)/3;
Form2->Canvas->MoveTo(TreeX,TreeT);
Form2->Canvas->LineTo(TreeX,TreeB);
Form2->Canvas->Pen->Color=clGreen;
for (i=1; i<=Nbr; i++) {
  Form2->Canvas->MoveTo(TreeX,TreeT+TreeDelta*(i-1));
  Form2->Canvas->LineTo(TreeX-Branch,TreeT+TreeDelta*i);
  Form2->Canvas->MoveTo(TreeX,TreeT+TreeDelta*(i-1));
  Form2->Canvas->LineTo(TreeX+Branch,TreeT+TreeDelta*i);
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm2::ViewFirTree(TObject *Sender)
{
ModalResult = mrOk; 	
}
//---------------------------------------------------------------------------